/*
    Aufgabe 5) Grafische Aufbereitung v. "Guessing Game" und Verwendung v. Methoden
*/

import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.Random;
import java.util.Scanner;

import codedraw.CodeDraw;
import codedraw.Palette;
import codedraw.textformat.HorizontalAlign;
import codedraw.textformat.TextFormat;

import javax.imageio.ImageIO;

public class Aufgabe5 {

    //TODO: Implementieren Sie hier Ihre Methoden

    public static String imgCoinHave = "./src/img_coin_have.jpg";
    public static String imgCoinLost = "./src/img_coin_lost.jpg";
    public static String arrowDown = "./src/arrow_down.png";
    public static String arrowUp = "./src/arrow_up.png";

    public static void main(String[] args) {

        int pixelWidth = 610;
        int pixelHeight = 160;
        CodeDraw myDrawObj = new CodeDraw(pixelWidth, pixelHeight);
        myDrawObj.setTitle("Guessing  Game");
        TextFormat format = myDrawObj.getTextFormat();
        format.setFontName("Times New Roman");
        format.setFontSize(30);
        format.setHorizontalAlign(HorizontalAlign.CENTER);


        //TODO: Implementieren Sie hier Ihr "GuessingGame"



        int secretNumber = generateRandom();
        int trys = 0;
        draw(myDrawObj, trys, 0);
        while(trys < 8) {
            int playerNum = getNumber();
            if (playerNum > secretNumber) {
                printMsg("Too High!");
                draw(myDrawObj, trys+1, 1);
            }
            else if (playerNum < secretNumber) {
                printMsg("Too Low!");
                draw(myDrawObj, trys+1, -1);
            }
            else if (playerNum == secretNumber) {
                printMsg("You win!");
                trys = 100;
                draw(myDrawObj, trys, 10);
            }
            trys++;
        }
        if (trys < 100) {
            printMsg("You lose");
            draw(myDrawObj, trys, 10);
        }
    }

    public static int generateRandom() {
        Random rand = new Random();
        return rand.nextInt(201);
    }

    public static int getNumber() {
        Scanner scanner = new Scanner(System.in);
        String s;
        while (true) {
            s = scanner.nextLine();
            if (s.matches("-?\\d+")) {
                int input = Integer.parseInt(s);
                if (0 <= input && input <= 200)
                    return input;
            }
            System.out.println("Ungültige Eingabe");
        }
    }

    public static void printMsg(String msg) {
        System.out.println(msg);
    }

    public static void draw(CodeDraw codeDraw, int trys, int betState) {
        codeDraw.clear();
        for (int i = 0; i < 8; i++) {
            if (i < trys)
                codeDraw.drawImage(5+i*75, 160-75, imgCoinLost);
            else
                codeDraw.drawImage(5+i*75, 160-75, imgCoinHave);
        }

        switch(betState) {
            case 10:
                if (trys >= 100) {
                    codeDraw.setColor(Color.green);
                    codeDraw.drawText(300, 10, "YOU WON!!!");
                }
                else {
                    codeDraw.setColor(Color.red);
                    codeDraw.drawText(300, 10, "You LOST!!!");
                }
                break;
            case 1:
                codeDraw.drawImage(50,0,arrowDown);
                codeDraw.drawText(300, 10, "Number is smaller!");
                break;
            case -1:
                codeDraw.drawImage(50,0,arrowUp);
                codeDraw.drawText(300, 10, "Number is greater!");
                break;
        }

        codeDraw.show();
    }

    /*  Zusatzfragen

    1. Wie können die eingegebenen Daten (bzw. deren Datentypen) bei der Verwendung des Scanners unterschieden werden?
    Mithilfe eines Regex

    2. Warum muss eine ungültige Eingabe aus dem Input-Stream des Scanners entfernt werden?
    Zum Benutzen der Eingabe in diesem Kontext muss sie eine numerische Ganzzahl sein
     */


}
